import scrapy
from datetime import datetime, date, timedelta

"""
USO:

scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=2 -a day=21
"""

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
    return TAG_RE.sub('', text)


class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()


class QuotesSpider(scrapy.Spider):
	name = 'noticias'
	def start_requests(self):
		self.section = ''
		self.page = 0
		self.count = 0
		self.found = False
		self.not_found = False
		self.next_section = False
		self.year = getattr(self, 'year', None)
		self.month = getattr(self, 'month', None)
		self.day = getattr(self, 'day', None)
		self.date = date(int(self.year), int(self.month), int(self.day))
		self.data_list = []
		self.baseURL = 'http://jornadabc.mx'
		# section_list = ['baja-california', 'chihuahua', 'mexico', 'mundo', 'cultura']
		section_list = ['baja-california', 'chihuahua', 'mexico', 'mundo', 'cultura']
		
		for section in section_list:
			self.section = section
			print self.section
			self.page = 0
			self.count = 0
			self.found = False
			self.not_found = False
			self.next_section = False
			self.data_list = []
			page = -1
			while True:
				if ( self.found ):
					self.found = False
					break
				if ( self.not_found ):
					self.not_found = False
					self.next_section = True
					break
				page += 1
				print 'page '+str(page)
				yield scrapy.Request(url=self.baseURL+'/seccion/'+section+'?page='+str(page), callback=self.parse, dont_filter=True)
			
			# if not ( self.next_section ):
			# 	self.next_section = False
			# 	self.page -= self.count
			# 	if ( self.page > 0 ):
			# 		self.page -= 1
					
			# 	for pag in range(self.page, self.page+25):
			# 		yield scrapy.Request(url=self.baseURL+'/seccion/'+section+'?page='+str(pag), callback=self.parse_page, dont_filter=True)				
			if ( len(self.data_list) > 0 ):
				for link in self.data_list:
					# link_date = datetime.strptime(link[:link.rfind('/')][link[:link.rfind('/')].rfind('/')+1:], '%d-%m-%Y').date()
					# if ( link[:link.rfind('/')][link[:link.rfind('/')].rfind('/')+1:] == self.day.zfill(2)+'-'+self.month.zfill(2)+'-'+self.year ):
					yield scrapy.Request(url=self.baseURL+link, callback=self.parse_item, dont_filter=True)

	
	def parse(self, response):
		print response.url
		count = 0
		this_page = int(response.url[response.url.rfind('=')+1:])

		if ( self.section == 'espectaculos' or self.section == 'deportes' ):
			path = '//*[@class="region region-soft-first"]'
		else:
			path = '//*[@class="region region-hard-first"]'

		link_list = response.xpath(path).css('div.views-row').xpath('./*[@class="views-field views-field-title"]/span[@class="field-content"]/a/@href').extract()
		
		if ( len(link_list) > 0 ):
			if ( this_page > 0 ):
				del link_list[0]
			print link_list
			for link in link_list:
				link_date = datetime.strptime(link[:link.rfind('/')][link[:link.rfind('/')].rfind('/')+1:], '%d-%m-%Y').date()
				print self.section+' '+link_date.isoformat()+' ? '+self.date.isoformat()
				if ( link_date.month == self.date.month and link_date.year == self.date.year ):
					# self.page = int(response.url[response.url.rfind('=')+1:])
					# self.count += 1
					# self.found = True
					# print '************founddddd********'
					# break
					self.data_list.append(link)

				if ( this_page >= 300 ):
					self.found = True
					break
		

			if ( this_page > 300 and len(link_list) == 0 ):
				self.not_found = True
				# if ( link_date < stop_date ):
				# 	# count += 1
				# 	# print count
				# 	# if ( count > 3 ):
				# 	self.not_found = True
				# 	break
				


	def parse_page(self, response):
		if ( self.section == 'espectaculos' or self.section == 'deportes' ):
			path = '//*[@class="region region-soft-first"]'
		else:
			path = '//*[@class="region region-hard-first"]'

		link_list = response.xpath(path).css('div.views-row').xpath('./*[@class="views-field views-field-title"]/span[@class="field-content"]/a/@href').extract()
		if ( len(link_list) > 0 ):
			for link in link_list:
				link_date = datetime.strptime(link[:link.rfind('/')][link[:link.rfind('/')].rfind('/')+1:], '%d-%m-%Y').date()
				if ( link_date == self.date ):
					yield scrapy.Request(url=self.baseURL+link, callback=self.parse_item)


	def parse_item(self, response):
		item = NoticiasItem()
		text = ''
		item['date'] = response.xpath('//meta[@property="article:published_time"]/@content').extract_first()
		title = response.xpath('//*[@class="block-content"]/h1/a/text()').extract()
		if ( len(title) > 0 ):
			item['title'] = title[0]
		else:
			item['title'] = response.xpath('//*[@class="block-content"]/h1/text()').extract_first()

		item['topic'] = response.xpath('//span[@class="section"]/text()').extract_first()
		for paragraph in response.xpath('//*[@class="field-item even"]/p/text()').extract():
			text += paragraph
		item['text'] = text
		item['url'] = response.url
		# print item['title']
		yield item
