import scrapy
import json

#scrapy crawl noticias -t json -o noticias.json

import re


TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
    return TAG_RE.sub('', text)


class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()


class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		self.baseURL = 'https://www.lajornadamaya.mx'
		# section_list = [('yucatan',123,'Yucatan'), ('quintana-roo',52,'Quintana Roo'),
		# 				('campeche',32,'Campeche'), ('opinion',0,'Opinion'), ('deportes',91,'Deportes'),
		# 				('nacional',100,'Nacional'), ('internacional',87,'Internacional')]
		section_list = [('opinion',0,'Opinion')]

		for section in section_list:
			self.section = section
			if not ( section[0] == 'opinion' ):
				for page in range(0,section[1]+1):
					yield scrapy.Request(url=self.baseURL+'/'+section[0]+'?p='+str(page), callback=self.parse)
			else:
				yield scrapy.Request(url=self.baseURL+'/notas?opinion', callback=self.parse)


	def parse(self, response):
		json_response = json.loads(response.text)

		if not ( self.section[0] == 'opinion' ):
			json_list = json_response
		else:
			json_list = json_response['articles']

		for line in json_list:
			item = NoticiasItem()
			item['date'] = line['publishDate']
			item['topic'] = self.section[2]
			item['title'] = line['name']
			if not ( self.section[0] == 'opinion' ):
				request = scrapy.Request(url=self.baseURL+line['url'], callback=self.parse_item)
			else:
				request = scrapy.Request(url=self.baseURL+'/'+line['publishDate'][:line['publishDate'].rfind(' ')]+'/'+line['uriComponent'], callback=self.parse_item)
			request.meta['item'] = item
			yield request


	def parse_item(self, response):
		item = response.meta['item']
		text = ''
		for paragraph in response.xpath('//*[@class="txt"]').extract():
			text += remove_tags(paragraph) + '\n'
		item['text'] = text
		item['url'] = response.url
		# print item['title']
		yield item

