import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
    return TAG_RE.sub('', text)


class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()


class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		year = getattr(self, 'year', None)
		month = getattr(self, 'month', None)
		day = getattr(self, 'day', None)
		self.baseURL='http://www.lajornadadeoriente.com.mx/'+year+'/'+month+'/'+day
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)


	def parse(self, response):
		for link in response.xpath('//div[@class="mas_noticias"]/ul[@class="sollet"]/li/a/@href').extract():
			yield scrapy.Request(url=link, callback=self.parse_item)


	def parse_item(self, response):
		item = NoticiasItem()
		text = ''
		item['title'] = response.xpath('//h1[@itemprop="headline"]/text()').extract_first()
		item['date'] = response.xpath('//meta[@property="article:published_time"]/@content').extract_first()
		item['topic'] = response.xpath('//span[@itemprop="genre"]/text()').extract_first()
		item['author'] = response.xpath('//span[@itemprop="name"]/text()').extract_first()
		for paragraph in response.xpath('//span[@itemprop="articleBody"]').extract():
			text += remove_tags(paragraph) + '\n'
		item['text'] = text
		item['url'] = response.url
		# print item['title']
		yield item

