import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
    return TAG_RE.sub('', text)


class NoticiasItem(scrapy.Item):
    title = scrapy.Field()
    text = scrapy.Field()
    date = scrapy.Field()
    location = scrapy.Field()
    author = scrapy.Field()
    topic = scrapy.Field()
    url = scrapy.Field()


class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		self.year = getattr(self, 'year', None)
		self.month = getattr(self, 'month', None)
		self.day = getattr(self, 'day', None)
		self.baseURL = 'http://www.jornadaveracruz.com.mx/'
		self.builtURL= self.baseURL+'Archive.aspx?date='+self.day.zfill(2)+'/'+self.month.zfill(2)+'/'+self.year
		urls = [
			self.builtURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)


	def parse(self, response):
		paths = ['//*[@class="article-header"]/h2/a/@href',
				 '//ul[@class="article-array content-category"]/li/a/@href']
		for path in paths:
			links = response.xpath(path).extract()
			if ( len(links) > 0 ):
				for link in links:
					yield scrapy.Request(url=self.baseURL+link, callback=self.parse_item)

		# for link in response.xpath('//*[@class="text_block_200"]/h2/a/@href').extract():
		# 	yield scrapy.Request(url=self.baseURL+'/'+link, callback=self.parse_page)


	def parse_page(self, response):
		paths = ['//*[@id="article_list"]/h2/a/@href',
				 '//*[@id="article_list"]/h3/a/@href']
		for path in paths:
			for link in response.xpath(path).extract():
				if not ( link in self.link_list ):
					yield scrapy.Request(url=self.baseURL+'/'+link, callback=self.parse_item)


	def parse_item(self, response):
		item = NoticiasItem()
		text = ''
		item['date'] = self.year+'-'+self.month.zfill(2)+'-'+self.day.zfill(2)
		item['title'] = response.xpath('//h2[@class="article-title"]/text()').extract_first()
		item['topic'] = response.xpath('//*[@class="content-article-title"]/h2/text()').extract()
		item['author'] = response.xpath('//*[@class="right-side"]/div/a[@rel="author"]/text()').extract_first()
		
		paragraph = response.xpath('//*[@class="shortcode-content"]/p/text()').extract()
		if ( len(paragraph) > 0 ):
			for p in paragraph:
				text += paragraph[3]
		else:
			for p in response.xpath('//*[@class="shortcode-content"]').extract():
				text += remove_tags(p) + '\n'

		item['text'] = text
		item['url'] = response.url
		# print item['title']
		yield item

